## mingw-w64-kfilemetadata-6.12.0-1.src.tar.zst

=== tests/CMakeLists.txt ===
add_executable(dump dump.cpp)
ecm_mark_nongui_executable(dump)

set_target_properties(dump PROPERTIES
    OUTPUT_NAME kfilemetadata_dump6
)
install(TARGETS dump
        DESTINATION ${KDE_INSTALL_BINDIR}
)

target_include_directories(dump  PUBLIC "$<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>")

target_link_libraries(dump
    Qt6::Core
    KF6FileMetaData
)

# Though the dump utility is not a regular test case, running it increases
# code coverage significantly
# We check if the output matches using a regular expression

add_test(NAME dump_fail COMMAND dump "${CMAKE_CURRENT_SOURCE_DIR}")
set_tests_properties(dump_fail PROPERTIES
    # Directories are not valid arguments
    WILL_FAIL TRUE
)

add_test(NAME dump_meta COMMAND dump "${CMAKE_CURRENT_SOURCE_DIR}/../autotests/samplefiles/test_plain_text_file.txt")
set_tests_properties(dump_meta PROPERTIES
    PASS_REGULAR_EXPRESSION "PlaintextExtractor"
)

add_test(NAME dump_fulltext COMMAND dump "-f" "${CMAKE_CURRENT_SOURCE_DIR}/../autotests/samplefiles/test_plain_text_file.txt")
set_tests_properties(dump_fulltext PROPERTIES
    PASS_REGULAR_EXPRESSION "Text: This"
)

add_test(NAME dump_meta_svg COMMAND dump "${CMAKE_CURRENT_SOURCE_DIR}/../autotests/samplefiles/test_dcterms.svg")
set_tests_properties(dump_meta_svg PROPERTIES
    PASS_REGULAR_EXPRESSION "Description: A test document"
)

=== src/extractors/CMakeLists.txt ===

if(TARGET Poppler::Qt6)
    add_library(kfilemetadata_popplerextractor MODULE popplerextractor.cpp)

    target_link_libraries(kfilemetadata_popplerextractor
        KF6::FileMetaData
        Poppler::Qt6
    )

    set_target_properties(kfilemetadata_popplerextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_popplerextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

endif()

if(Taglib_FOUND)
    add_library(kfilemetadata_taglibextractor MODULE taglibextractor.cpp ${debug_SRCS})
    target_link_libraries( kfilemetadata_taglibextractor
        KF6::FileMetaData
        Taglib::Taglib
    )

    set_target_properties(kfilemetadata_taglibextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_taglibextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)
endif()

if(LibExiv2_FOUND)
    add_library(kfilemetadata_exiv2extractor MODULE exiv2extractor.cpp ${debug_SRCS})
    kde_target_enable_exceptions(kfilemetadata_exiv2extractor PRIVATE)
    target_link_libraries(kfilemetadata_exiv2extractor
        KF6::FileMetaData
        LibExiv2::LibExiv2
    )
    if(${LibExiv2_VERSION} VERSION_GREATER_EQUAL 0.27.4)
        set(EXIV2_HAVE_BMFF_SUPPORT "1")
    endif()
    configure_file(exiv2extractor.json.in exiv2extractor.json)

    set_target_properties(kfilemetadata_exiv2extractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")

    if (${LibExiv2_VERSION} VERSION_LESS 0.28.0)
	# exiv2 0.27.x still uses std::auto_ptr, which is incompatible with C++17
        set_target_properties(kfilemetadata_exiv2extractor PROPERTIES CXX_STANDARD 14)
    endif()

    install(
    TARGETS kfilemetadata_exiv2extractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

endif()

if(AVCODEC_FOUND AND AVFORMAT_FOUND AND AVUTIL_FOUND)
    add_library(kfilemetadata_ffmpegextractor MODULE
        ffmpegextractor.cpp
        ../kfilemetadata_debug.cpp
    )
    target_include_directories(kfilemetadata_ffmpegextractor SYSTEM PRIVATE ${AVCODEC_INCLUDE_DIRS} ${AVFORMAT_INCLUDE_DIRS} ${AVUTIL_INCLUDE_DIRS})
    target_link_libraries(kfilemetadata_ffmpegextractor
        KF6::FileMetaData
	${AVCODEC_LIBRARIES}
	${AVFORMAT_LIBRARIES}
	${AVUTIL_LIBRARIES}
    )

    set_target_properties(kfilemetadata_ffmpegextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_ffmpegextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

endif()


if(EPUB_FOUND)
    add_library(kfilemetadata_epubextractor MODULE
        epubextractor.cpp
        ../kfilemetadata_debug.cpp
    )
    target_include_directories(kfilemetadata_epubextractor SYSTEM PRIVATE ${EPUB_INCLUDE_DIR})
    target_link_libraries(kfilemetadata_epubextractor
        KF6::FileMetaData
        ${EPUB_LIBRARIES}
    )

    set_target_properties(kfilemetadata_epubextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_epubextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

endif()

#
# Plain Text
#
add_library(kfilemetadata_plaintextextractor MODULE plaintextextractor.cpp)

target_link_libraries( kfilemetadata_plaintextextractor
    KF6::FileMetaData
    KF6::Codecs
)

set_target_properties(kfilemetadata_plaintextextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
install(
TARGETS kfilemetadata_plaintextextractor
DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

#
# PO
#
add_library(kfilemetadata_poextractor MODULE poextractor.cpp)
target_link_libraries( kfilemetadata_poextractor
    KF6::FileMetaData
)

set_target_properties(kfilemetadata_poextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
install(
TARGETS kfilemetadata_poextractor
DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

#
# XML
#
set_package_properties(KF6Archive PROPERTIES PURPOSE "- Required for extracting data from compressed SVGs")
add_library(kfilemetadata_xmlextractor MODULE
   dublincoreextractor.cpp
   xmlextractor.cpp
   ../kfilemetadata_debug.cpp
)
target_link_libraries( kfilemetadata_xmlextractor
    KF6::FileMetaData
    Qt6::Core
    Qt6::Xml
)
if(KF6Archive_FOUND)
    target_link_libraries(kfilemetadata_xmlextractor KF6::Archive)
    target_compile_definitions(kfilemetadata_xmlextractor PRIVATE SVG_XML_COMPRESSED_SUPPORT=1)
endif()

set_target_properties(kfilemetadata_xmlextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
install(
    TARGETS kfilemetadata_xmlextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata
)

#
# Postscript DSC
#
add_library(kfilemetadata_postscriptdscextractor MODULE
   postscriptdscextractor.cpp
   ../kfilemetadata_debug.cpp
)
target_link_libraries( kfilemetadata_postscriptdscextractor
    KF6::FileMetaData
    Qt6::Core
)

set_target_properties(kfilemetadata_postscriptdscextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
install(
    TARGETS kfilemetadata_postscriptdscextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata
)

#
# ODF
#
set_package_properties(KF6Archive PROPERTIES PURPOSE "- Required for ODF extractor")
if(KF6Archive_FOUND)
    add_library(kfilemetadata_odfextractor MODULE odfextractor.cpp ${debug_SRCS})

    target_link_libraries(kfilemetadata_odfextractor
        KF6::FileMetaData
        Qt6::Core
        Qt6::Xml
        KF6::Archive
    )

    set_target_properties(kfilemetadata_odfextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_odfextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)
endif()

#
# Office 2007
#
set_package_properties(KF6Archive PROPERTIES PURPOSE "- Required for Office 2007 extractor")
if(KF6Archive_FOUND)
    add_library(kfilemetadata_office2007extractor MODULE
        office2007extractor.cpp
        dublincoreextractor.cpp
        ${debug_SRCS}
    )

    target_link_libraries(kfilemetadata_office2007extractor
        KF6::FileMetaData
        Qt6::Core
        Qt6::Xml
        KF6::Archive
    )

    set_target_properties(kfilemetadata_office2007extractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_office2007extractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)
endif()

#
# Office (binary formats)
#

add_library(kfilemetadata_officeextractor MODULE)
target_sources(kfilemetadata_officeextractor
    PRIVATE
        officeextractor.cpp
        ${debug_SRCS}
)

target_link_libraries(kfilemetadata_officeextractor
    KF6::FileMetaData
)

set_target_properties(kfilemetadata_officeextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
install(
TARGETS kfilemetadata_officeextractor
DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

#
# Mobipocket
#
if (QMobipocket6_FOUND)
    add_library(kfilemetadata_mobiextractor MODULE mobiextractor.cpp)
    target_link_libraries(kfilemetadata_mobiextractor
        KF6::FileMetaData
        QMobipocket6
    )

    set_target_properties(kfilemetadata_mobiextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_mobiextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)

endif()

set_package_properties(Qt6Gui PROPERTIES PURPOSE "- Required for AppImage extractor")
if(libappimage_FOUND AND KF6Config_FOUND AND Qt6Gui_FOUND)
    add_library(kfilemetadata_appimageextractor MODULE appimageextractor.cpp )
    target_link_libraries( kfilemetadata_appimageextractor
        KF6::FileMetaData
        KF6::ConfigCore
        Qt6::Xml
        Qt6::Gui
        libappimage
    )

    set_target_properties(kfilemetadata_appimageextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_appimageextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)
endif()

set_package_properties(Qt6Gui PROPERTIES PURPOSE "- Required for Qt based PNG extractor")
if(Qt6Gui_FOUND)
    add_library(kfilemetadata_pngextractor MODULE pngextractor.cpp )
    target_link_libraries(kfilemetadata_pngextractor
        KF6::FileMetaData
        Qt6::Gui
    )

    set_target_properties(kfilemetadata_pngextractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_pngextractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)
endif()

#
# FictionBook2
#
set_package_properties(KF6Archive PROPERTIES PURPOSE "- Required for FictionBook2 extractor")
if(KF6Archive_FOUND)
    add_library(kfilemetadata_fb2extractor MODULE fb2extractor.cpp ${debug_SRCS})
    target_link_libraries(kfilemetadata_fb2extractor
        KF6::Archive
        KF6::FileMetaData
        Qt6::Core
    )

    set_target_properties(kfilemetadata_fb2extractor PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_fb2extractor
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)
endif()

#
# Krita
#
set_package_properties(KF6Archive PROPERTIES PURPOSE "- Required for Krita extractor")
if(KF6Archive_FOUND)
    add_library(kfilemetadata_krita MODULE)
    target_sources(kfilemetadata_krita
        PRIVATE
            kritaextractor.cpp
    )

    target_link_libraries(kfilemetadata_krita
        KF6::FileMetaData
        KF6::Archive
    )

    set_target_properties(kfilemetadata_krita PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kfilemetadata")
    install(
    TARGETS kfilemetadata_krita
    DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfilemetadata)
endif()

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

source "$(dirname ${BASH_SOURCE[0]})"/../mingw-w64-PKGBUILD-common/kde-frameworks
_realname=kfilemetadata
pkgbase="mingw-w64-${_realname}"
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=6.12.0
pkgrel=1
pkgdesc="A library for extracting file metadata (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
msys2_references=(
  'archlinux: kfilemetadata'
)
msys2_repository_url='https://invent.kde.org/frameworks/kfilemetadata/'
url='https://community.kde.org/Frameworks/'
license=('spdx:LGPL-2.0-or-later')
depends=(
  "${MINGW_PACKAGE_PREFIX}-ebook-tools"
  "${MINGW_PACKAGE_PREFIX}-exiv2"
  "${MINGW_PACKAGE_PREFIX}-ffmpeg"
  "${MINGW_PACKAGE_PREFIX}-karchive"
  "${MINGW_PACKAGE_PREFIX}-kcodecs"
  "${MINGW_PACKAGE_PREFIX}-kconfig"
  "${MINGW_PACKAGE_PREFIX}-kcoreaddons"
  "${MINGW_PACKAGE_PREFIX}-ki18n"
  "${MINGW_PACKAGE_PREFIX}-poppler-qt6"
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-taglib"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
  "${MINGW_PACKAGE_PREFIX}-gettext-tools"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
groups=("${MINGW_PACKAGE_PREFIX}-kf6")
source=("https://download.kde.org/stable/frameworks/${pkgver%.*}/${_realname}-${pkgver}.tar.xz"{,.sig}
       "0001-kfilemetadata-allow-ffmpeg-pkgconfig.patch")
sha256sums=('5fb39a3705154317eeff78b7eba776b51a44634a1216b60ebe7f62ecc11318f7'
            'SKIP'
            '0a864a4223f47d7cf78400f218a3e61c9d790ab401423722bb009aad4f8b3610')
validpgpkeys=(
  'E0A3EB202F8E57528E13E72FD7574483BB57B18D' # Jonathan Esk-Riddell <jr@jriddell.org>
  '90A968ACA84537CC27B99EAF2C8DF587A6D4AAC1' # Nicolas Fella <nicolas.fella@kde.org>
)

prepare() {
  cd "${_realname}-${pkgver}"
  patch -p1 -i "${srcdir}/0001-kfilemetadata-allow-ffmpeg-pkgconfig.patch"
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _kde_build_env
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_KDE_INSTALL_DIRS[@]}" \
      -DBUILD_QCH=OFF \
      -DBUILD_TESTING=OFF \
      "${_extra_config[@]}" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
